Class.create(function(Super)
 /**
  * OCjVCU[NX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.log.LogInitializerNX
  * 
  * @package js.debug.log
  * @update 2007/09/23
  * @version 1.01.00
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX́uJavaScriptLoggervgp\ɂ邽߂̊e평A
  *   Oo͐ݒt@C(XML)ɎŎsB</p>
  * @example <p>Oo͐ݒt@Cǂݍ݁A̓eɏs߂ɂ́A
  *   <var>Static</var><var>initialize</var>\bhs΂悢B
  *   ȂOɐݒt@CɂĎgp`ĂNXincludeς݂łKvB
  *   ReiuEUłꍇ́ÂƂinclude<var>initialize</var>\bh̊Ԃ
  *   x&lt;script&gt;^O؂KvBi̊ԂɃNXinclude邽߁j</p>
  *   <pre><code>
  *     
  *     // KvNX̃CN[h
  *     include("js.cpt.Log");
  *     include("js.debug.log.*", true);
  *     
  *   //--&gt;&lt;/script&gt;
  *   
  *   
  *   &lt;script type="text/javascript"&gt;&lt;!--
  *     // uEUŎgpꍇ́Axscript^O؂KvB
  *     
  *     js.debug.log.LogInitializer.Static.initialize(Oo͐ݒt@C̃pX, true);
  *     // ȍ~̃XNvgsɂāAݒt@CɊÂOo͂\ƂȂB
  *     
  *   </code></pre>
  * @explanation <p><var>LogInitializer</var>œǂݍރOo͐ݒt@ĆAȉ̍\KvƂB<br />
  *   <kbd>@</kbd>͑A<kbd>#text</kbd>͗B̎qvfłeLXgA
  *   <kbd><span style="font-weight:bold;color:red;margin-left:0.5ex;">?</span></kbd>,<kbd><span style="font-weight:bold;color:red;margin-left:0.5ex;">*</span></kbd>,<kbd><span style="font-weight:bold;color:red;margin-left:0.5ex;">+</span></kbd>DTDƓlɏo񐔂ӖĂB</p>
  *   <pre style="background-color:#EEEEEE;border:inset 2px white;"><code>
  *   &lt;log-properties&gt;
  *   @@@version = "1.0"
  *   @
  *   @&lt;log-class&gt;
  *   @@&lt;factory-class&gt;
  *   @@@@@#text = "js.cpt.Log"iŒlj
  *   @@&lt;implemented-class&gt;
  *   @@@@@@#text = "js.debug.log.Log"iŒlj
  *   @
  *   @&lt;log-level&gt;
  *   @@&lt;default-level&gt;
  *   @@@@@#text = "-1"|"0"|"1"|"2"|"3"|"4"|"5"|"IGNORE"|"FATAL"|"ERROR"|"WARN"|"INFO"|"DEBUG"|"TRACE"
  *   @@
  *   @@&lt;fatal-next&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">?</span>
  *   @@@@@#text = "-1"|"0"|"1"|"2"|"3"|"4"|"5"|"IGNORE"|"FATAL"|"ERROR"|"WARN"|"INFO"|"DEBUG"|"TRACE"
  *   @@&lt;error-next&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">?</span>
  *   @@@@@#text = "-1"|"0"|"1"|"2"|"3"|"4"|"5"|"IGNORE"|"FATAL"|"ERROR"|"WARN"|"INFO"|"DEBUG"|"TRACE"
  *   @@&lt;warn-next&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">?</span>
  *   @@@@@#text = "-1"|"0"|"1"|"2"|"3"|"4"|"5"|"IGNORE"|"FATAL"|"ERROR"|"WARN"|"INFO"|"DEBUG"|"TRACE"
  *   @@&lt;info-next&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">?</span>
  *   @@@@@#text = "-1"|"0"|"1"|"2"|"3"|"4"|"5"|"IGNORE"|"FATAL"|"ERROR"|"WARN"|"INFO"|"DEBUG"|"TRACE"
  *   @@&lt;debug-next&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">?</span>
  *   @@@@@#text = "-1"|"0"|"1"|"2"|"3"|"4"|"5"|"IGNORE"|"FATAL"|"ERROR"|"WARN"|"INFO"|"DEBUG"|"TRACE"
  *   @@&lt;trace-next&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">?</span>
  *   @@@@@@#text = "-1"|"0"|"1"|"2"|"3"|"4"|"5"|"IGNORE"|"FATAL"|"ERROR"|"WARN"|"INFO"|"DEBUG"|"TRACE"
  *   @
  *   @&lt;log-stocker&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">*</span>
  *   @@@@@name = OXgbJ[NX̓o^(s)
  *   @@@@#text = OXgbJ[NX̊SCNX
  *   @
  *   @&lt;log-appender&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">*</span>
  *   @@@@@name = OAy_[NX̓o^(a)
  *   @@@@#text = OAy_[NX̊SCNX
  *   @
  *   @&lt;log-define&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">*</span>
  *   @@@@name = Oo͒`̓o^(d)
  *   @@&lt;use-stocker&gt;
  *   @@@@@@name = OXgbJ[NX̓o^(s)
  *   @@@@&lt;use-appender&gt;
  *   @@@@@@@@name = OAy_[NX̓o^(a)
  *   @@@@@@
  *   @@@@@@&lt;param&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">*</span>
  *   @@@@@@@@@@@name = p[^[ieAy_[NX̉QƁj
  *   @@@@@@@@@@#text = p[^[lieAy_[NX̉QƁj
  *   @
  *   @&lt;log-mapping&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">*</span>
  *   @@@@@name = Oo͒`̓o^(d)
  *   @@@&lt;mapping-key&gt;<span style="font-weight:bold;color:red;margin-left:0.5ex;">+</span>
  *   @@@@@@@#text = Oo̓L[iOCX^X̑Pj| nullinulll͂P񂾂gpj
  *   </code></pre>
  * @explanation <p>o^OXgbJ[⃍OAy_[͑SăOo͒`ŎgpȂ΂ȂȂƂ͂Ȃ̂ŁA
  *   gp\̂NX͗\ߓo^ĂƂłB
  *   Ȁꍇ͓o^NX̓CN[hς݂łȂ΂ȂȂB<br />
  *   lɁAOo͒`͑SăOo̓}bsOŎgpȂ΂ȂȂƂ͂Ȃ̂ŁA
  *   gp\̂郍Oo͒`\ߓo^ĂƂłB</p>
  *   <p>XgbJ[ƃAy_[̑IѕƓɂĂ͒`t@CyъeNX̉QƂ̂ƁB</p>
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.log.LogInitializer";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  // js.cpt.Class
  var _Class_ = js.cpt.Class;
  
  //
  // NX
  //
  //------------------------------------------------------------------------------
  //:V XmlNode Function XmlNodeNX(js.debug.log.LogInitializerNX)
  var XmlNode = (function()
    {
    var Proto = Class.prototype;
    //--------------------------------------
    //:P appendChild@V:XmlNode Function
    Proto.appendChild = function(node)
     /**
      * m[hǉ
      * @param node XmlNode ǉm[h
      */
      {
      node.parentNode = this;
      this.childNodes[this.childNodes.length] = node;
      if(!this.firstChild)
        {
        this.firstChild = node;
        }
      if(this.lastChild)
        {
        this.lastChild.nextSibling = node;
        node.previousSibling = this.lastChild;
        }
      this.lastChild = node;
      };
    //--------------------------------------
    //:P getChildByTagName@V:XmlNode Function
    Proto.getChildByTagName = function(tagName)
     /**
      * ^Oqm[h擾
      * @notice ŏɌm[hԂB
      * @param tagName String ^O
      * @return XmlNode|null Yqm[h
      */
      {
      for(var i = 0; i < this.childNodes.length; i++)
        {
        if(this.childNodes[i].nodeName == tagName)
          {
          return this.childNodes[i];
          }
        }
      return null;
      };
    //--------------------------------------
    //:P getChildrenByTagName@V:XmlNode Function
    Proto.getChildrenByTagName = function(tagName)
     /**
      * ^Oqm[h̔z擾
      * @param tagName String ^O
      * @return Array qm[h(XmlNode)̔z
      */
      {
      var children = new Array();
      for(var i = 0; i < this.childNodes.length; i++)
        {
        if(this.childNodes[i].nodeName == tagName)
          {
          children[children.length] = this.childNodes[i];
          }
        }
      return children;
      };
    //--------------------------------------
    //:P setAttribute@V:XmlNode Function
    Proto.setAttribute = function(name, value)
     /**
      * ݒ肷
      * @param name String 
      * @param value String l
      */
      {
      this.attributes[name] = value;
      };
    //--------------------------------------
    //:P getAttribute@V:XmlNode Function
    Proto.getAttribute = function(name)
     /**
      * 擾
      * @param name String 
      * @return String|undefined l
      */
      {
      return this.attributes[name];
      };
    //--------------------------------------
    //:P getText@V:XmlNode Function
    Proto.getText = function()
     /**
      * ^ÕeLXg擾
      * @return String|null ^ÕeLXg
      */
      {
      return (this.text ? this.text : (this.nodeValue ? this.nodeValue : null));
      };
    //--------------------------------------
    //:P getValue@V:XmlNode Function
    Proto.getValue = function()
     /**
      * ^O̒l擾
      * @return String|null ^O̒l
      */
      {
      return (this.nodeValue ? this.nodeValue : (this.text ? this.text : null));
      };
    //--------------------------------------
    //:P toString@V:XmlNode Function
    Proto.toString = function(firstNest, stepNest, lineSeparator)
     /**
      * ^O𕶎(XML)
      * @param firstNest [String] ŏ̃lXg
      * @param stopNest [String] lXgXebv(Kw[ȂxɃlXgɒǉ)
      * @param lineSeparator [String] sR[h
      * @return String ^O
      */
      {
      if(typeof firstNest != "string")
        {
        firstNest = "";
        }
      if(typeof stepNest != "string")
        {
        stepNest = "";
        }
      if(typeof lineSeparator != "string")
        {
        lineSeparator = "";
        }
      var text = "";
      switch(this.nodeName)
        {
        case "#text":
          text = this.text ? this.text : '';
          break;
        case "#cdata-section":
          text = firstNest + '<![CDATA[' + this.getValue() + ']]>' + lineSeparator;
          break;
        case "#comment":
          text = firstNest + '<' + '!-' + '-' + this.getText() + '-' + '->' + lineSeparator;
          break;
        case "#document":
        case "#document-fragment":
          break;
        default:
          text = firstNest + '<' + this.nodeName;
          for(var name in this.attributes)
            {
            text += ' ' + name + '="' + this.getAttribute(name) + '"';
            }
          text += '>';
          if(this.childNodes.length > 0)
            {
            if(this.firstChild.nodeName != "#text")
              {
              text += lineSeparator;
              }
            for(var idx = 0; idx < this.childNodes.length; idx++)
              {
              text += arguments.callee.call(this.childNodes[idx], (firstNest + stepNest), stepNest, lineSeparator);
              }
            if(this.lastChild.nodeName != "#text")
              {
              text += firstNest;
              }
            }
          text += '</' + this.nodeName + '>';
          text += lineSeparator;
          break;
        }
      return text;
      };
    //--------------------------------------
    //:F Class@V:XmlNode Function
    function Class(nodeName, nodeValue)
     /**
      * XmlNodeNX(js.debug.log.LogInitializerNX)
      * @param nodeName String m[h
      * @param nodeValue [String] m[h̒l
      * @return XmlNode CX^X
      */
      {
      this.nodeName = nodeName;
      this.nodeValue = nodeValue ? nodeValue : null;
      this.parentNode = null;
      this.childNodes = new Array();
      this.firstChild = null;
      this.lastChild = null;
      this.previousSibling = null;
      this.nextSibling = null;
      this.attributes = new Object();
      return this;
      }
    return Class;
    })();
  //------------------------------------------------------------------------------
  //:V XmlReader Function XmlReaderNX(js.debug.log.LogInitializerNX)
  var XmlReader = (function()
    {
    var Proto = Class.prototype;
    //--------------------------------------
    //:F loadXmlAtGecko@V:XmlReader Function
    function loadXmlAtGecko(url)
     /**
      * GeckonuEUXML[h
      * @param url String XMLURL
      * @return js.debug.log.LogInitializer.XmlNode
      */
      {
      var xmlDom = null;
      var domDoc = document.implementation.createDocument("", "", null);
      domDoc.async = false;
      //domDoc.onload = loadHandler;
      domDoc.load(url);
      //function loadHandler()
        {
        if(domDoc && domDoc.documentElement)
          {
          xmlDom = copyNode(domDoc.documentElement);
          }
        }
      return xmlDom;
      }
    //--------------------------------------
    //:F loadXmlAtMsie@V:XmlReader Function
    function loadXmlAtMsie(url)
     /**
      * MSIEuEUXML[h
      * @param url String XMLURL
      * @return js.debug.log.LogInitializer.XmlNode
      * @throw SecurityException@Error ActiveX(MSXML.DOMDocument)łȂꍇ
      */
      {
      var xmlDom = null;
      // Zp o[Wɂ(Microsoft.XMLDOMMSXML.DOMDocumentMSXML2.DOMDocumentMSXML2.DOMDocument.3.0MSXML2.DOMDocument.4.0)
      var domDoc = new ActiveXObject("MSXML.DOMDocument");
      if(!domDoc)
        {
        throw new Error("SecurityException", Creator.CompleteName, "XML[_[(MSXML.DOMDocument)ł܂łB");
        }
      domDoc.async = false;
      if(domDoc.load(url))
        {
        var rootNode = domDoc.documentElement;
        if(rootNode)
          {
          xmlDom = copyNode(rootNode);
          }
        }
      return xmlDom;
      }
    //--------------------------------------
    //:F copyNode@V:XmlReader Function
    function copyNode(inNode)
     /**
      * m[hRs[
      * @param inNode Object Rs[m[h
      * @return js.debug.log.LogInitializer.XmlNode m[h̃Rs[
      */
      {
      var outNode = new XmlNode(inNode.nodeName);
      if(inNode.nodeName.charAt(0) == "#")
        {
        outNode.nodeValue = inNode.nodeValue;
        outNode.text      = inNode.text;
        }
      else
        {
        for(var idx = 0; idx < inNode.attributes.length; idx++)
          {
          outNode.setAttribute(inNode.attributes[idx].name, inNode.attributes[idx].value);
          }
        for(var idx = 0; idx < inNode.childNodes.length; idx++)
          {
          outNode.appendChild(arguments.callee(inNode.childNodes[idx]));
          }
        }
      return outNode;
      }
    //--------------------------------------
    //:P load@V:XmlNode Function
    Proto.load = function(url)
     /**
      * URLXMLt@C[h
      * @param url String XMLt@CURL
      * @return XmlNode XML̃[gm[h
      */
      {
      var xmlDom = null;
      try
        {
        if(document.implementation && ((typeof document.implementation.createDocument) == "function"))
          {
          xmlDom = loadXmlAtGecko(url);
          }
        else if((typeof ActiveXObject) == "function")
          {
          xmlDom = loadXmlAtMsie(url);
          }
        }
      catch(e)
        {
        xmlDom = null;
        if(debugMode)
          {
          throw e;
          }
        }
      return xmlDom;
      };
    //--------------------------------------
    //:F Class@V:XmlNode Function
    function Class()
     /**
      * XmlReaderNX(js.debug.log.LogInitializerNX)
      * @return XmlReader CX^X
      */
      {
      return this;
      }
    return Class;
    })();
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  /**
   * fobO[hǂ
   * @def V
   * @name debugMode
   * @type Boolean
   * @explanation true:fobO[hCfalse:TCƃ[h
   */
  var debugMode = false;
  
  //------------------------------------------------------------------------------
  function loadXml(url)
   /**
    * XMLt@C[h
    * @param url String XMLt@CURL(pX܂)
    * @return XmlNode|null DOM̃[gm[h
    */
    {
    var xmlDom = null;
    var reader = new XmlReader();
    xmlDom = reader.load(url);
    return xmlDom;
    }
  //------------------------------------------------------------------------------
  function getText(node, defaultValue)
   /**
    * ^OeLXgo
    * @param node XmlNode ^O
    * @param defaultValue [String] ftHgl
    * @return String oeLXg
    */
    {
    var child = node.getChildByTagName("#text");
    if(!child)
      {
      child = node.getChildByTagName("#cdata-section");
      }
    if(child)
      {
      return child.getText();
      }
    else if(arguments.length > 1)
      {
      return defaultValue;
      }
    else
      {
      throw node.nodeName;
      }
    }
  //------------------------------------------------------------------------------
  function getValue(node, defaultValue)
   /**
    * ^Olo
    * @param node XmlNode ^O
    * @param defaultValue [String] ftHgl
    * @return String ol
    */
    {
    var child = node.getChildByTagName("#cdata-section");
    if(!child)
      {
      child = node.getChildByTagName("#text");
      }
    if(child)
      {
      return child.getValue();
      }
    else if(arguments.length > 1)
      {
      return defaultValue;
      }
    else
      {
      throw node.nodeName;
      }
    }
  //------------------------------------------------------------------------------
  function parseDom2Mapping(xmlDom)
   /**
    * DOM}bsOɕϊ
    * @param xmlDom XmlNode DOM̃[gm[h
    * @return js.debug.log.LogInitializer }bsO
    */
    {
    var mapping = new Class();
    var tagName = null;
    try
      {
      // <log-properties>
      tagName = "log-properties";
      if(xmlDom.nodeName != tagName)
        {
        throw tagName;
        }
      // <log-class>
      tagName = "log-class";
      var logClass = xmlDom.getChildrenByTagName(tagName);
      if(logClass.length != 1)
        {
        throw tagName;
        }
      logClass = logClass[0];
      // <factory-class>
      tagName = "factory-class";
      var factory = logClass.getChildrenByTagName(tagName);
      if(factory.length != 1)
        {
        throw tagName;
        }
      factory = factory[0];
      mapping.setFactoryClass(getText(factory));
      // <implemented-class>
      tagName = "implemented-class";
      var imple = logClass.getChildrenByTagName(tagName);
      if(imple.length != 1)
        {
        throw tagName;
        }
      imple = imple[0];
      mapping.setImplementedClass(getText(imple));
      // <log-level>
      tagName = "log-level";
      var logLevel = xmlDom.getChildrenByTagName(tagName);
      if(logLevel.length != 1)
        {
        throw tagName;
        }
      logLevel = logLevel[0];
      var dl_ok = false;
      for(var c = 0; c < logLevel.childNodes.length; c++)
        {
        var child = logLevel.childNodes[c];
        switch(child.nodeName)
          {
          case "default-level":
            mapping.setDefaultLevel(getText(child));
            dl_ok = true;
            break;
          case "fatal-next":
            mapping.setFatalNext(getText(child));
            break;
          case "error-next":
            mapping.setErrorNext(getText(child));
            break;
          case "warn-next":
            mapping.setWarnNext(getText(child));
            break;
          case "info-next":
            mapping.setInfoNext(getText(child));
            break;
          case "debug-next":
            mapping.setDebugNext(getText(child));
            break;
          case "trace-next":
            mapping.setTraceNext(getText(child));
            break;
          default:
            if(child.nodeName.charAt(0) != "#")
              {
              throw child.nodeName;
              }
            break;
          }
        }
      if(!dl_ok)
        {
        throw "defalut-level";
        }
      // <log-stocker>
      tagName = "log-stocker";
      var stockers = xmlDom.getChildrenByTagName(tagName);
      for(var i = 0; i < stockers.length; i++)
        {
        mapping.setStocker(stockers[i].getAttribute("name"), getText(stockers[i]));
        }
      // <log-appender>
      tagName = "log-appender";
      var appenders = xmlDom.getChildrenByTagName(tagName);
      for(var i = 0; i < appenders.length; i++)
        {
        mapping.setAppender(appenders[i].getAttribute("name"), getText(appenders[i]));
        }
      // <log-define>
      tagName = "log-define";
      var defines = xmlDom.getChildrenByTagName(tagName);
      for(var i = 0; i < defines.length; i++)
        {
        var stocker = defines[i].getChildByTagName("use-stocker");
        var appender = stocker.getChildByTagName("use-appender");
        var params = appender.getChildrenByTagName("param");
        var paramObj = {};
        for(var p = 0; p < params.length; p++)
          {
          var param_name  = params[p].getAttribute("name");
          var param_value = getValue(params[p], "");
          if(paramObj[param_name] == undefined)
            {
            paramObj[param_name] = param_value;
            }
          else if((typeof paramObj[param_name]) == "string")
            {
            paramObj[param_name] = [paramObj[param_name], param_value];
            }
          else
            {
            paramObj[param_name][paramObj[param_name].length] = param_value;
            }
          }
        mapping.setDefine(defines[i].getAttribute("name"), stocker.getAttribute("name"), appender.getAttribute("name"), paramObj);
        }
      // <log-mapping>
      tagName = "log-mapping";
      var mappings = xmlDom.getChildrenByTagName(tagName);
      for(var i = 0; i < mappings.length; i++)
        {
        var keyList = [];
        var keys = mappings[i].getChildrenByTagName("mapping-key");
        for(var k = 0; k < keys.length; k++)
          {
          keyList[k] = getText(keys[k], null);
          }
        if(keyList.length > 0)
          {
          mapping.setMapping(mappings[i].getAttribute("name"), keyList);
          }
        }
      }
    catch(e)
      {
      if(mapping)
        {
        mapping.destroy();
        }
      mapping = null;
      if(debugMode)
        {
        throw e;
        }
      }
    return mapping;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Static.initialize = function(url, isDebugMode)
   /**
    * O
    * @notice URL,XMLt@C,XML̉͂ȂǂŖ肪ꍇ́A͖B
    * @param url String Oo͐ݒt@CURL(vgR(file܂http)n܂URLw肷)
    * @param isDebugMode [Boolean] fobO[hŏ邩ǂ(true:fobO[h/false,ȗ:TCg)
    * @return Boolean ǂ
    * @throw StringFormatException@Error fobO[hŁAurl̒lv~eBuString^ł͂Ȃꍇ
    */
    {
    debugMode = isDebugMode ? true : false;
    if((typeof url) != "string")
      {
      if(debugMode)
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"url", value:url, type:(typeof url)});
        }
      else
        {
        return false;
        }
      }
    // XMLt@C̃[h
    var xmlDom = loadXml(url);
    if(!xmlDom)
      {
      return false;
      }
    // XMLt@C̉
    var mapping = parseDom2Mapping(xmlDom);
    if(!mapping)
      {
      return false;
      }
    // ͓e̎s
    try
      {
      mapping.initialize();
      }
    catch(e)
      {
      if(debugMode)
        {
        throw e;
        }
      return false;
      }
    finally
      {
      mapping.destroy();
      }
    return true;
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * LogInitializerNX̃RXgN^
    * @return js.debug.log.LogInitializer CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v factoryName String t@Ng[NX
    var factoryName = "js.cpt.Log";
    
    //:v factoryClass Function|null t@Ng[NX(js.cpt.LogŒ)
    var factoryClass = null;
    //:v implementedClass Function|null NX(js.cpt.Log̃TuNX)
    var implementedClass = null;
    
    //:v defaultLevel Number|null ftHgx
    var defaultLevel = null;
    //:v fatalNext Number|null FATALJڃx
    var fatalNext = null;
    //:v errorNext Number|null ERRORJڃx
    var errorNext = null;
    //:v warnNext Number|null WARNJڃx
    var warnNext = null;
    //:v infoNext Number|null INFOJڃx
    var infoNext = null;
    //:v debugNext Number|null DEBUGJڃx
    var debugNext = null;
    //:v tarceNext Number|null TRACEJڃx
    var traceNext = null;
    
    //:v stockerMap Object XgbJ[NX}bv
    var stockerMap = {};
    
    //:v appenderMap Object Ay_[NX}bv
    var appenderMap = {};
    
    //:v defineMap Object O`}bv
    var defineMap = {};
    
    //:v mappingMap Object }bsO}bv
    var mappingMap = {};
    
    //------------------------------------------------------------------------------
    function getClass(className)
     /**
      * NXNX擾
      * @condition łɃCN[hς݂̃NXw肷B
      * @param className String NX
      * @throw ConditionException@Error classNameŎw肳ꂽNX擾łȂꍇ
      */
      {
      var classObj = _Class_.getClass(className, true);
      if(!classObj)
        {
        throw new Error("ConditionException", Creator.CompleteName, ("NX " + className + " ̓CN[hς݂ł͂܂B"));
        }
      return classObj;
      }
    //------------------------------------------------------------------------------
    function toInteger(num)
     /**
      * 𐮐ɕϊ
      * @param num String ̕\
      * @return Number 
      * @throw NumberFormatException@Error num̕𐔒lɕϊłȂꍇ
      */
      {
      var n = null;
      try
        {
        n = parseInt(num);
        if(isNaN(n))
          {
          n = null;
          }
        }
      catch(e)
        {
        n = null;
        }
      if((typeof n) == "number")
        {
        return n;
        }
      else
        {
        throw new Error("NumberFormatException", Creator.CompleteName, {variable:"num", value:num, type:(typeof num)});
        }
      }
    //------------------------------------------------------------------------------
    function toLevel(lev)
     /**
      * Ox񂩂烍Oxlɕϊ
      * @condition NX(ϐimple)ݒς݂łȂ΂ȂȂB
      * @param lev String Ox\
      * @return Number Ox\l
      * @throw UndefinedException@Error levŎw肳ꂽOxNX܂͂̃X[p[NXŖ`̏ꍇ
      * @throw ConditionException@Error NXݒς݂łȂ̂ɂ̃\bhsꍇ
      */
      {
      if(!isNaN(lev))
        {
        return toInteger(lev);
        }
      else if(imple)
        {
        var num = imple.Static["LEVEL_" + lev];
        if(((typeof num) != "number") || !imple.Static.LEVEL_NAMES || (imple.Static.LEVEL_NAMES[num] != lev))
          {
          throw new Error("UndefinedException", Creator.CompleteName, ("x " + lev + " ́ANX܂͂̃X[p[NXŖ`łB"));
          }
        }
      else
        {
        throw new Error("ConditionException", Creator.CompleteName, "toLevel\bhsƂ͎NXݒς݂łKv܂B");
        }
      }
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.setFactoryClass = function(className)
     /**
      * t@Ng[NXݒ肷
      * @condition łɃCN[hς݂̃NXw肷B
      * @param className String t@Ng[NXiŒl:"js.debug.Log"j
      * @throw StringRangeException@Error <factory-class>̒l"js.debug.Log"(Œl)łȂꍇ
      * @throw DoubleDefinitionException@Error <factory-class>Qȏoꍇ
      */
      {
      // <factory-class>̒ljs.debug.Log(Œ)łȂꍇ
      if(className != factoryName)
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"className", range:"\"js.debug.Log\"", value:className});
        }
      // <factory-class>Qȏoꍇ
      if(factoryClass)
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "t@Ng[NX𕡐ݒ肷邱Ƃ͂ł܂B");
        }
      var factory = getClass(className);
      factoryClass = factory;
      };
    //------------------------------------------------------------------------------
    this.setImplementedClass = function(className)
     /**
      * NXݒ肷
      * @condition t@Ng[NXi<factory-class>m[hjɐݒς݂łKvB
      * @param className String NX
      * @throw ConditionException@Error t@Ng[NXݒ肳ĂȂꍇ
      * @throw RangeException@Error <implemented-class>Ŏw肳ꂽNXt@Ng[NX̃TuNXłȂꍇ
      * @throw DoubleDefinitionException@Error <implemented-class>Qȏoꍇ
      */
      {
      // <factory-class>O<implemented-class>oꍇ
      if(!factoryClass)
        {
        throw new Error("ConditionException", Creator.CompleteName, "NX̐ݒOɃt@Ng[NXݒ肷Kv܂B");
        }
      var imple = getClass(className);
      // <implemented-class>̒l擾NXjs.debug.Log̃TuNXłȂꍇ
      if(imple.property instanceof factoryClass)
        {
        throw new Error("RangeException", Creator.CompleteName, ("NX(" + className + ")̓t@Ng[NX̃TuNXł͂܂B"));
        }
      // <implemented-class>Qȏoꍇ
      if(implementedClass)
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "NX𕡐ݒ肷邱Ƃ͂ł܂B");
        }
      implementedClass = imple;
      };
    //------------------------------------------------------------------------------
    this.setDefaultLevel = function(level)
     /**
      * ftHgxݒ肷
      * @param level String ftHgx
      * @throw DoubleDefinitionException@Error <default-level>Qȏoꍇ
      */
      {
      level = toLevel(level);
      // <default-level>Qȏoꍇ
      if((typeof defaultLevel) == "number")
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "ftHgx𕡐ݒ肷邱Ƃ͂ł܂B");
        }
      defaultLevel = level;
      };
    //------------------------------------------------------------------------------
    this.setFatalNext = function(level)
     /**
      * FATALJڃxݒ肷
      * @param level String ftHgx
      * @throw DoubleDefinitionException@Error <fatal-next>Qȏoꍇ
      */
      {
      level = toLevel(level);
      // <fatal-next>Qȏoꍇ
      if((typeof fatalNext) == "number")
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "FATALJڃx𕡐ݒ肷邱Ƃ͂ł܂B");
        }
      fatalNext = level;
      };
    //------------------------------------------------------------------------------
    this.setErrorNext = function(level)
     /**
      * ERRORJڃxݒ肷
      * @param level String ftHgx
      * @throw DoubleDefinitionException@Error <error-next>Qȏoꍇ
      */
      {
      level = toLevel(level);
      // <error-next>Qȏoꍇ
      if((typeof errorNext) == "number")
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "ERRORJڃx𕡐ݒ肷邱Ƃ͂ł܂B");
        }
      errorNext = level;
      };
    //------------------------------------------------------------------------------
    this.setWarnNext = function(level)
     /**
      * WARNJڃxݒ肷
      * @param level String ftHgx
      * @throw DoubleDefinitionException@Error <warn-next>Qȏoꍇ
      */
      {
      level = toLevel(level);
      // <warn-next>Qȏoꍇ
      if((typeof warnNext) == "number")
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "WARNJڃx𕡐ݒ肷邱Ƃ͂ł܂B");
        }
      warnNext = level;
      };
    //------------------------------------------------------------------------------
    this.setInfoNext = function(level)
     /**
      * INFOJڃxݒ肷
      * @param level String ftHgx
      * @throw DoubleDefinitionException@Error <info-next>Qȏoꍇ
      */
      {
      level = toLevel(level);
      // <info-next>Qȏoꍇ
      if((typeof infoNext) == "number")
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "INFOJڃx𕡐ݒ肷邱Ƃ͂ł܂B");
        }
      infoNext = level;
      };
    //------------------------------------------------------------------------------
    this.setDebugNext = function(level)
     /**
      * DEBUGJڃxݒ肷
      * @param level String ftHgx
      * @throw DoubleDefinitionException@Error <debug-next>Qȏoꍇ
      */
      {
      level = toLevel(level);
      // <debug-next>Qȏoꍇ
      if((typeof debugNext) == "number")
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "DEBUGJڃx𕡐ݒ肷邱Ƃ͂ł܂B");
        }
      debugNext = level;
      };
    //------------------------------------------------------------------------------
    this.setTraceNext = function(level)
     /**
      * TRACEJڃxݒ肷
      * @param level String ftHgx
      * @throw DoubleDefinitionException@Error <trace-next>Qȏoꍇ
      */
      {
      level = toLevel(level);
      // <trace-next>Qȏoꍇ
      if((typeof traceNext) == "number")
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "TRACEJڃx𕡐ݒ肷邱Ƃ͂ł܂B");
        }
      traceNext = level;
      };
    //------------------------------------------------------------------------------
    this.setStocker = function(name, className)
     /**
      * XgbJ[NXݒ肷
      * @param name String ݒ薼
      * @param className String XgbJ[NX
      * @throw StringRangeException@Error <stocker-class>nameݒ肳ĂȂꍇ
      * @throw RangeException@Error <stocker-class>Őݒ肵NXjs.debug.log.AbstractLogStocker̃TuNXłȂꍇ
      * @throw DoubleDefinitionException@Error namel<stocker-class>Qȏoꍇ
      */
      {
      // <stocker-class>nameݒ肳ĂȂꍇ
      if(!name)
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"name", range:"NotEmptyString", value:name});
        }
      var classObj = getClass(className);
      var superClass = getClass("js.debug.log.AbstractLogStocker");
      // <stocker-class>Őݒ肵NXjs.debug.log.AbstractLogStocker̃TuNXłȂꍇ
      if(!(classObj.prototype instanceof superClass))
        {
        throw new Error("RangeException", Creator.CompleteName, ("XgbJ[NX(" + className + ")js.debug.log.AbstractLogStocker̃TuNXłȂ΂Ȃ܂B"));
        }
      // namel<stocker-class>Qȏoꍇ
      if(stockerMap[name] || stockerMap.hasOwnProperty(name))
        {  
        throw new Error("DoubleDefinitionException", Creator.CompleteName, ("O(" + name + ")Ŋɓo^ꂽXgbJ[NX܂B"));
        }
      stockerMap[name] = classObj;
      };
    //------------------------------------------------------------------------------
    this.setAppender = function(name, className)
     /**
      * Ay_[NXݒ肷
      * @param name String ݒ薼
      * @param className String Ay_[NX
      * @throw StringRangeException@Error <appender-class>nameݒ肳ĂȂꍇ
      * @throw RangeException@Error <appender-class>Őݒ肵NXjs.debug.log.AbstractLogAppender̃TuNXłȂꍇ
      * @throw DoubleDefinitionException@Error namel<appender-class>Qȏoꍇ
      */
      {
      // <appender-class>nameݒ肳ĂȂꍇ
      if(!name)
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"name", range:"NotEmptyString", value:name});
        }
      var classObj = getClass(className);
      var superClass = getClass("js.debug.log.AbstractLogAppender");
      // <appender-class>Őݒ肵NXjs.debug.log.AbstractLogAppender̃TuNXłȂꍇ
      if(!(classObj.prototype instanceof superClass))
        {
        throw new Error("RangeException", Creator.CompleteName, ("Ay_[NX(" + className + ")js.debug.log.AbstractLogAppender̃TuNXłȂ΂Ȃ܂B"));
        }
      // namel<appender-class>Qȏoꍇ
      if(appenderMap[name] || appenderMap.hasOwnProperty(name))
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, ("O(" + name + ")Ŋɓo^ꂽAy_[NX܂B"));
        }
      appenderMap[name] = classObj;
      };
    //------------------------------------------------------------------------------
    this.setDefine = function(name, stockerName, appenderName, appenderParams)
     /**
      * O`ݒ肷
      * @param name String ݒ薼
      * @param stockerName String XgbJ[
      * @param appenderName String Ay_[
      * @param appenderParams Object Ay_[p[^[
      * @throw StringRangeException@Error <log-define>nameݒ肳ĂȂꍇ
      * @throw StringRangeException@Error <use-stocker>nameݒ肳ĂȂꍇ
      * @throw StringRangeException@Error <use-appender>nameݒ肳ĂȂꍇ
      * @throw FormatException@Error appenderParamsIuWFNgłȂꍇ
      * @throw UndefinedException@Error <use-stocker>nameƓname<stocker-class>݂Ȃꍇ
      * @throw UndefinedException@Error <use-appender>nameƓname<appender-class>݂Ȃꍇ
      * @throw DoubleDefinitionException@Error name<log-define>Qȏoꍇ
      */
      {
      // <log-define>nameݒ肳ĂȂꍇ
      if(!name)
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"name", range:"NotEmptyString", value:name});
        }
      // <use-stocker>nameݒ肳ĂȂꍇ
      if(!stockerName)
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"stockerName", range:"NotEmptyString", value:stockerName});
        }
      // <use-appender>nameݒ肳ĂȂꍇ
      if(!appenderName)
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"appenderName", range:"NotEmptyString", value:appenderName});
        }
      // appenderParamsIuWFNgłȂꍇ
      if((typeof appenderParams) != "object")
        {
        throw new Error("FormatException", Creator.CompleteName, {variable:"appenderParams", value:appenderParams, type:(typeof appenderParams)});
        }
      // `ς݃`FbN
      // <use-stocker>nameƓname<stocker-class>݂Ȃꍇ
      if(!stockerMap.hasOwnProperty(stockerName))
        {
        throw new Error("UndefinedException", Creator.CompleteName, ("O " + stockerName + " œo^ꂽXgbJ[NX݂͑܂B"));
        }
      // <use-appender>nameƓname<appender-class>݂Ȃꍇ
      if(!appenderMap.hasOwnProperty(appenderName))
        {
        throw new Error("UndefinedException", Creator.CompleteName, ("O " + appenderName + " œo^ꂽXgbJ[NX݂͑܂B"));
        }
      // name<log-define>Qȏoꍇ
      if(defineMap[name] || defineMap.hasOwnProperty(name))
        {  
        throw new Error("DoubleDefinitionException", Creator.CompleteName, ("O(" + name + ")Ŋɓo^ꂽO`܂B"));
        }
      // O`ǉ
      var stocker = stockerMap[stockerName];
      var appender = appenderMap[appenderName];
      defineMap[name] = function()
        {
        return new stocker(new appender(appenderParams));
        };
      };
    //------------------------------------------------------------------------------
    this.setMapping = function(name, keys)
     /**
      * }bsOݒ肷
      * @param name String }bsO
      * @param keys Array }bsOL[(String)̔z
      * @throw StringRangeException@Error <log-mapping>nameݒ肳ĂȂꍇ
      * @throw FormatException@Error <log-mapping>qvf(<mapping-key>)PȂꍇ
      * @throw UndefinedException@Error <log-mapping>nameƓname<log-define>݂Ȃꍇ
      * @throw DoubleDefinitionException@Error name<log-mapping>Qȏoꍇ
      * @throw StringFormatException@Error keys̗vfnullł`łv~eBu̕łȂ̂܂ޏꍇ
      */
      {
      // <log-mapping>nameݒ肳ĂȂꍇ
      if(!name)
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"name", range:"NotEmptyString", value:name});
        }
      // <log-mapping>qvf(<mapping-key>)PȂꍇ
      if(!keys || !(keys instanceof Array))
        {
        throw new Error("FormatException", Creator.CompleteName, {variable:"keys", format:"Array", value:keys, type:(typeof keys)});
        }
      // <log-mapping>nameƓname<log-define>݂Ȃꍇ
      if(!defineMap.hasOwnProperty(name))
        {
        throw new Error("UndefinedException", Creator.CompleteName, ("O " + name + " œo^ꂽO`݂͑܂B"));
        }
      // name<log-mapping>Qȏoꍇ
      if(mappingMap[name] || mappingMap.hasOwnProperty(name))
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, ("O(" + name + ")Ŋɓo^ꂽ}bsO܂B"));
        }
      // }bsOǉ
      mappingMap[name] = (function()
        {
        for(var i = 0; i < arguments.length; i++)
          {
          if(arguments[i] && ((typeof arguments[i]) != "string"))
            {
            throw new Error("StringFormatException", Creator.CompleteName, {variable:("keys["+i+"]"), value:arguments[i], type:(typeof arguments[i])});
            }
          }
        return arguments;
        }).apply(null, keys);
      };
    //------------------------------------------------------------------------------
    this.initialize = function()
     /**
      * OCjVCY
      */
      {
      // NX̓o^
      factoryClass.setImplementedClass(implementedClass);
      // Ox̓o^
      factoryClass.Static.level = defaultLevel;
      if((typeof fatalNext) == "number")
        {
        implementedClass.Static.fatalNext = fatalNext;
        }
      if((typeof errorNext) == "number")
        {
        implementedClass.Static.errorNext = errorNext;
        }
      if((typeof warnNext) == "number")
        {
        implementedClass.Static.warnNext = warnNext;
        }
      if((typeof infoNext) == "number")
        {
        implementedClass.Static.infoNext = infoNext;
        }
      if((typeof debugNext) == "number")
        {
        implementedClass.Static.debugNext = debugNext;
        }
      if((typeof traceNext) == "number")
        {
        implementedClass.Static.traceNext = traceNext;
        }
      // }bsO
      for(var m in mappingMap)
        {
        var mappingList = mappingMap[m];
        for(var i = 0; i < mappingList.length; i++)
          {
          var keyName = mappingList[i];
          if(!keyName)
            {
            keyName = null;
            }
          var define = defineMap[m];
          if((typeof define) == "function")
            {
            define = define();
            defineMap[m] = define;
            }
          implementedClass.Static.setStocker(keyName, define);
          }
        }
      };
    //------------------------------------------------------------------------------
    this.destroy = function()
     /**
      * CX^X̕ϐ(ꕔ̃f[^ێp)J
      */
      {
      delete factoryClass;
      delete implementedClass;
      delete defaultLevel;
      delete fatalNext;
      delete errorNext;
      delete warnNext;
      delete infoNext;
      delete debugNext;
      delete traceNext;
      delete stockerMap;
      delete appenderMap;
      delete defineMap;
      delete mappingMap;
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  });

