Class.create(function(Super)
 /**
  * K[NX(JavaScriptLogger)
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.log.LogNX
  * 
  * @package js.debug.log
  * @update 2007/09/18
  * @version 2.00.00
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX́uJavaScriptLoggervɂꂽK[NXłB
  *   ̃NXgpۂ́A\<var>js.cpt.Log</var>ɓo^ĂA
  *   CX^X<kbd>new js.cpt.Log(L[)</kbd>ƂĐB</p>
  *   <p>܂A\߃XgbJ[i<var>AbstractLogStocker</var>̃CX^XjL[ƌтēo^ĂKvB
  *   ̂ƂAP̃XgbJ[IuWFNgʂ̃L[ŕo^邱Ƃ\łB
  *   ɂACX^XɎw肵L[ƈvXgbJ[
  *   ivL[̃XgbJ[ȂAftHgXgbJ[o^Ăꍇ̓ftHgXgbJ[j
  *   ɑ΂ăOo͂sƂłB</p>
  * @rel js.cpt.Log
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.log.Log";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  // js.debug.log.AbstractLogStocker
  var AbstractLogStocker = js.debug.log.AbstractLogStocker;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V defaultLogStocker js.debug.log.AbstractLogStocker|null ftHg̃OXgbJ[
  var defaultLogStocker = null;
  //:V logStockerMap Object OXgbJ[(js.debug.log.AbstractLogStocker^)}bv
  var logStockerMap = {};
  
  //------------------------------------------------------------------------------
  function getStocker(key)
   /**
    * OXgbJ[擾
    * @param key String|null Oo̓L[
    * @return js.debug.log.AbstractLogStocker|null OXgbJ[(AbstractLogStocker̃TuNX̃CX^X)
    */
    {
    var stocker = null;
    if(key)
      {
      stocker = logStockerMap[key];
      }
    if(!stocker)
      {
      stocker = defaultLogStocker;
      }
    return stocker;
    }
  //------------------------------------------------------------------------------
  function setStocker(key, stocker)
   /**
    * OXgbJ[ݒ肷
    * @param key String|null Oo̓L[
    * @param stocker js.debug.log.AbstractLogStocker OXgbJ[(AbstractLogStocker̃TuNX̃CX^X)
    */
    {
    if(key)
      {
      logStockerMap[key] = stocker;
      }
    else
      {
      defaultLogStocker = stocker;
      }
    }
  //------------------------------------------------------------------------------
  function setNextLevel(level)
   /**
    * OxJڂ
    * @param level [Number] Jڐ̃Ox
    * @explanation Ƃ肠exnextɎsĂ悢B
    *              ̃\bh̒őJڂ邩ǂ̔fsB
    * @explanation [Zp]X[p[NXlevel͕ύXȂB
    *              ̃NXStaticŕύXAlevelI[o[ChĂB
    *              X[p[NXlevelύXɂ́A
    *              Super.Static.levelύXKvB
    * @explanation [Zp]TuNXlevelI[o[ChꂽꍇA
    *              ̕ύX͗LƂ͂ȂȂB(̃NXStaticŕύX邽)
    *              KLɂ邽߂ɂ́AthisCX^XɂĎsA
    *              this.constructor.Static.levelɑKvB
    */
    {
    if((typeof level) == "number")
      {
      Static.level = level;  // ZpFJSDQƂ̂ƁB
      }
    }
  //------------------------------------------------------------------------------
  function resetLogLevel()
   /**
    * OxftHgɖ߂(Zbg)
    * @explanation [Zp]setNextLevel\bhlevel̃I[o[Ch
    *              sĂ邱ƂOɓ삷BI[o[Ch폜B
    *              TuNXlevelI[o[ChĂꍇŁA
    *              KZbg邽߂ɂ́AthisCX^XɂĎsA
    *              this.constructor.Static.level = Super.Static.leve;ƂB
    */
    {
    delete Static.level;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S fatalNext Number|null OxJfatal
  Static.fatalNext = null;
  //:S errorNext Number|null OxJerror
  Static.errorNext = null;
  //:S warnNext Number|null OxJwarn
  Static.warnNext  = null;
  //:S infoNext Number|null OxJinfo
  Static.infoNext  = null;
  //:S debugNext Number|null OxJdebug
  Static.debugNext = null;
  //:S traceNext Number|null OxJtrace
  Static.traceNext = null;
  
  //------------------------------------------------------------------------------
  Static.setStocker = function(key, stocker)
   /**
    * OXgbJ[ݒ肷
    * @param key String|null Oo̓L[
    * @param stocker js.debug.log.AbstractLogStocker OXgbJ[(AbstractLogStocker̃TuNX̃CX^X)
    * @throw StringFormatException@Error keynullłv~eBuString^łȂꍇ
    * @throw StringRangeException@Error key󕶎̏ꍇ
    * @throw FormatException@Error stockerjs.debug.log.AbstractLogStocker^iTuNXjłȂꍇ
    */
    {
    if((key !== null) && ((typeof key) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, {variable:"key", value:key, type:(typeof key)});
      }
    else if(!key && ((typeof key) == "string"))
      {
      throw new Error("StringRangeException", Creator.CompleteName, {variable:"key", range:"NotEmpty", value:key});
      }
    if(!stocker || ((typeof stocker) != "object") || !(stocker instanceof AbstractLogStocker) || (stocker.constructor == AbstractLogStocker))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"stocker", format:"js.debug.log.AbstractLogStocker", value:stocker, type:(typeof stocker)});
      }
    setStocker(key, stocker);
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.reset = function()
   /**
    * Ox̃Zbgs
    */
    {
    resetLogLevel();
    };
  //------------------------------------------------------------------------------
  Proto.fatal = function()
   /**
    * fatalx̃Oo͂s
    * @params [String|null] O
    */
    {
    if(this.constructor && this.constructor.Static)
      {
      if(this.constructor.Static.level >= this.constructor.Static.LEVEL_FATAL)
        {
        var key = ((typeof this.getKey) == "function") ? this.getKey() : null;
        var stocker = getStocker(key);
        if(stocker)
          {
          stocker.stock(new Date(), key, Static.LEVEL_NAMES[Static.LEVEL_FATAL], arguments);
          }
        setNextLevel(this.constructor.Static.fatalNext)
        }
      }
    };
  //------------------------------------------------------------------------------
  Proto.error = function()
   /**
    * errorx̃Oo͂s
    * @params [String|null] O
    */
    {
    if(this.constructor && this.constructor.Static)
      {
      if(this.constructor.Static.level >= this.constructor.Static.LEVEL_ERROR)
        {
        var key = ((typeof this.getKey) == "function") ? this.getKey() : null;
        var stocker = getStocker(key);
        if(stocker)
          {
          stocker.stock(new Date(), key, Static.LEVEL_NAMES[Static.LEVEL_ERROR], arguments);
          }
        setNextLevel(this.constructor.Static.errorNext);
        }
      }
    };
  //------------------------------------------------------------------------------
  Proto.warn = function()
   /**
    * warnx̃Oo͂s
    * @params [String|null] O
    */
    {
    if(this.constructor && this.constructor.Static)
      {
      if(this.constructor.Static.level >= this.constructor.Static.LEVEL_WARN)
        {
        var key = ((typeof this.getKey) == "function") ? this.getKey() : null;
        var stocker = getStocker(key);
        if(stocker)
          {
          stocker.stock(new Date(), key, Static.LEVEL_NAMES[Static.LEVEL_WARN], arguments);
          }
        setNextLevel(this.constructor.Static.warnNext);
        }
      }
    };
  //------------------------------------------------------------------------------
  Proto.info = function()
   /**
    * infox̃Oo͂s
    * @params [String|null] O
    */
    {
    if(this.constructor && this.constructor.Static)
      {
      if(this.constructor.Static.level >= this.constructor.Static.LEVEL_INFO)
        {
        var key = ((typeof this.getKey) == "function") ? this.getKey() : null;
        var stocker = getStocker(key);
        if(stocker)
          {
          stocker.stock(new Date(), key, Static.LEVEL_NAMES[Static.LEVEL_INFO], arguments);
          }
        setNextLevel(this.constructor.Static.infoNext);
        }
      }
    };
  //------------------------------------------------------------------------------
  Proto.debug = function()
   /**
    * debugx̃Oo͂s
    * @params [String|null] O
    */
    {
    if(this.constructor && this.constructor.Static)
      {
      if(this.constructor.Static.level >= this.constructor.Static.LEVEL_DEBUG)
        {
        var key = ((typeof this.getKey) == "function") ? this.getKey() : null;
        var stocker = getStocker(key);
        if(stocker)
          {
          stocker.stock(new Date(), key, Static.LEVEL_NAMES[Static.LEVEL_DEBUG], arguments);
          }
        setNextLevel(this.constructor.Static.debugNext);
        }
      }
    };
  //------------------------------------------------------------------------------
  Proto.trace = function()
   /**
    * tracex̃Oo͂s
    * @params [String|null] O
    */
    {
    if(this.constructor && this.constructor.Static)
      {
      if(this.constructor.Static.level >= this.constructor.Static.LEVEL_TRACE)
        {
        var key = ((typeof this.getKey) == "function") ? this.getKey() : null;
        var stocker = getStocker(key);
        if(stocker)
          {
          stocker.stock(new Date(), key, Static.LEVEL_NAMES[Static.LEVEL_TRACE], arguments);
          }
        setNextLevel(this.constructor.Static.traceNext);
        }
      }
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(key)
   /**
    * K[NX̃RXgN^
    * @notice <em>ʏ͂̊֐𒼐<kbd>new</kbd>ăCX^X𐶐ȂB</em>
    * @param key [String] Oo̓L[(ʏ͊SCNXw)
    * @return js.debug.log.Log CX^X
    * @throw StringFormatException@Error key`łv~eBuString^łȂꍇ
    * @throw StringRangeException@Error key󕶎̏ꍇ
    */
    {
    if((key !== undefined) && ((typeof key) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, {variable:"key", value:key, type:(typeof key)});
      }
    else if(!key && ((typeof key) == "string"))
      {
      throw new Error("StringRangeException", Creator.CompleteName, {variable:"key", value:key, type:(typeof key)});
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.getKey = function()
     /**
      * Oo̓L[擾
      * @return String Oo̓L[
      */
      {
      return key;
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    if(!key)
      {
      key = null;
      }
    return this;
    }
  
  return Class;
  }, js.cpt.Log);

